# Ion.Range Slider 1.9.0

> <a href="readme.md">English description</a> | Описание на русском

Удобный легкий слайдер диапазонов. <a href="http://ionden.com/a/plugins/ion.rangeSlider/">Страница проекта и демо</a>

Скачать: <a href="http://ionden.com/a/plugins/ion.rangeSlider/ion.rangeSlider-1.9.0.zip">ion.rangeSlider-1.9.0.zip</a>

***

## Описание
* Ion.RangeSlider — классный, удобный и легко настраиваемый слайдер диапазонов
* Слайдер поддерживает события и публичные методы, имеет гибкие настройки, может быть полностью видоизменен через CSS
* Кроссбраузерная поддержка: Google Chrome, Mozilla Firefox 3.6+, Opera 12+, Safari 5+, Internet Explorer 8+
* Плагин поддерживает устройства с touch-экраном (iPhone, iPad, Nexus, etc.)
* <a href="https://github.com/IonDen/ion.rangeSlider">Репозиторий на GitHub</a>
* Плагин свободно распространяется на условиях <a href="http://ionden.com/a/plugins/licence.html" target="_blank">лицензии MIT</a>

## Ключевые особенности
* Поддержка скинов. (3 скина в комплекте и PSD для изготовления собственных)
* Неограниченное кол-во слайдеров на одной странице без существенных потерь производительности и конфликтов между ними
* Два режима работы с 1 или 2 ползунками
* Поддержка отрицательных и дробных значений
* Возможность редактировать шаг
* Поддержка собственного диапазона значений (см. пример с месяцами)
* Автоматически генерируемая сетка
* Отключаемые элементы интерфейса (мин. и макс. значение, текущие значение, сетка)
* Постфиксы и префиксы для указания единиц измерения ($20, 20 &euro; и т.п.)
* Дополнительный постфикс для максимального значения (например $0 — $100<b>+</b>)
* Воможнось улучшить читабельность больших цифр (например 10000000 -> 10 000 000)
* Слайдер пишет свое значение прямо в value исходного поля input, что позволяет вставить сладер прямо внутрь любой формы
* Любой параметр слайдера можно так же задать через data-атрибут (например data-min="10")
* Слайдер поддерживает параметр disabled, позволяет делать слайдер неактивным
* Слайдер поддерживает внешние методы (update и remove), позволяющие управлять слайдером уже после создания
* Для продвинутых пользователей есть поддержка функций обратного вызова (onLoad, onChange, onFinish). Слайдер передает свои значения в эти функции первым аргументом в виде объекта

## Зависимости
* <a href="http://jquery.com/" target="_blank">jQuery 1.9+</a>


## Использование

Подключаем библиотеки:
* jQuery
* ion.rangeSlider.min.js

Подключаем стили:
* normalize.min.css (желательно, если он у вас еще не подключен)
* ion.rangeSlider.css

Не забываем про скин. 2 скина включены в архив:
* ion.rangeSlider.skinNice.css
* ion.rangeSlider.skinSimple.css

Не забудьте подключить картинку-спрайт скина:
* sprite-skin-simple.png - простецкий скин
* sprite-skin-nice.png - приличный скин
Либо воспользуйтесь вложенным в архив PSD файлом, и нарисуйте собственный скин (не забудьте модифицировать размеры элементов в CSS файле)


## Инициализация

Создаем базовое поле <code>input type="text"</code>:
```html
<input type="text" id="example_id" name="example_name" value="10;100" />
```

Чтобы запустить слайдер, вызовите ionRangeSlider для нужного элемента:
```javascript
$("#example_id").ionRangeSlider();
```

## Настройка

<table class="options">
    <thead>
        <tr>
            <th>Атрибут</th>
            <th>По умолчанию</th>
            <th>Описание</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>type</td>
            <td>"single"</td>
            <td>Не обязательный параметр, позволяет выбрать тип слайдера, может принимать значение <code>single</code> - для одиночного слайдера или <code>double</code> - для двойного слайдера</td>
        </tr>
        <tr>
            <td>min</td>
            <td>10</td>
            <td>Не обязательный параметр, автоматически устанавливается из атрибута <code>value</code> базового поля input. Например если value="10;100", то примет значение 10</td>
        </tr>
        <tr>
            <td>max</td>
            <td>100</td>
            <td>Не обязательный параметр, автоматически устанавливается из атрибута <code>value</code> базового поля input. Например если value="10;100", то примет значение 100</td>
        </tr>
        <tr>
            <td>from</td>
            <td>min</td>
            <td>Не обязательный параметр, по умолчанию равен значению min. Позволяет задать стартовую позицию слайдера "ОТ"</td>
        </tr>
        <tr>
            <td>to</td>
            <td>max</td>
            <td>Не обязательный параметр, по умолчанию равен значению max. Позволяет задать стартовую позицию слайдера "ДО"</td>
        </tr>
        <tr>
            <td>step</td>
            <td>1</td>
            <td>Не обязательный параметр, задает шаг слайдера</td>
        </tr>
        <tr>
            <td>prefix</td>
            <td>-</td>
            <td>Не обязательный параметр, добавляет текст до всех значений. Например prefix - "$" модифицирует значение "100" в "$100"</td>
        </tr>
        <tr>
            <td>postfix</td>
            <td>-</td>
            <td>Не обязательный параметр, добавляет текст после всех значений. Например postfix - " &euro;" модифицирует значение "100" в "100 &euro;"</td>
        </tr>
        <tr>
            <td>maxPostfix</td>
            <td>-</td>
            <td>Не обязательный параметр, добавляет для максимального значения. Например maxPostfix - "+" модифицирует значение "100" в "100+"</td>
        </tr>
        <tr>
            <td>hasGrid</td>
            <td>false</td>
            <td>Не обязательный параметр, включает сетку ниже слайдера (высота увеличивается на 20px и это можно настроить через CSS)</td>
        </tr>
        <tr>
            <td>hideMinMax</td>
            <td>false</td>
            <td>Не обязательный параметр, отключает поля Min и Max</td>
        </tr>
        <tr>
            <td>hideFromTo</td>
            <td>false</td>
            <td>Не обязательный параметр, отключает поля From и To</td>
        </tr>
        <tr>
            <td>prettify</td>
            <td>true</td>
            <td>Не обязательный параметр, позволяет разделять длинные цифры пробелами, например 10 000 вместо 10000</td>
        </tr>
        <tr>
            <td>disable</td>
            <td>false</td>
            <td>Визуально отключает слайдер</td>
        </tr>
        <tr>
            <td>values</td>
            <td>null</td>
            <td>Массив предустановленных значений: [a, b, c] и т.п.</td>
        </tr>
    </tbody>
</table>


## Колбэки

<table class="options">
    <thead>
        <tr>
            <th>Атрибут</th>
            <th>По умолчанию</th>
            <th>Описание</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>onLoad</td>
            <td>-</td>
            <td>Функция обратного вызова, вызывается один раз при инициализации слайдера или после обновления через метод Update</td>
        </tr>
        <tr>
            <td>onChange</td>
            <td>-</td>
            <td>Callback функция, вызывается каждый раз при смене состояния слайдера, возвращает объект, содержащий параметры слайдера</td>
        </tr>
        <tr>
            <td>onFinish</td>
            <td>-</td>
            <td>Callback функция, вызывается один раз при смене состояния слайдера, когда работа слайдера завершена. Возвращает объект, содержащий параметры слайдера</td>
        </tr>
    </tbody>
</table>


## Описание данных передаваемых в функцию обратного вызова:
В любую функцию обратного вызова передается объект с данными сладера:
```javascript
Obj: {
    "input": object,    // jQuery-ссылка на input
    "slider": object,   // jQuery-ссылка на контейнер слайдера
    "min": 10,          // значение MIN
    "max": 20,          // значение MAX
    "fromNumber": 10,   // значение ОТ
    "toNumber": 20,     // значение ДО
    "fromPers": 25,     // значение ОТ в процентах
    "toPers": 75,       // значение ДО в процентах
    "fromX": 100,       // координата x ползунка-ОТ в пикселях
    "toX": 200          // координата x ползунка-ДО в пикселях
}
```

## Создание слайдера (подробно)
Пример слайдера, запущенного с параметрами:
```javascript
$("#someID").ionRangeSlider({
    min: 10,                        // минимальное значение
    max: 100,                       // максимальное значение
    from: 30,                       // предустановленное значение ОТ
    to: 80,                         // предустановленное значение ДО
    type: "single",                 // тип слайдера
    step: 10,                       // шаг слайдера
    prefix: "$",                    // префикс значение
    postfix: " €",                  // постфикс значение
    maxPostfix: "+",                // постфикс для максимального значения
    hasGrid: true,                  // показать сетку
    hideMinMax: true,               // спрятать поля Min и Max
    hideFromTo: true,               // спрятать поля From и To
    prettify: true,                 // разделять цифры пробелами 10 000
    disable: false,                 // заблокировать слайдер
    values: ["a", "b", "c"],        // массив предустановленных значений
    onLoad: function (obj) {        // callback, вызывается при запуске и обновлении
        console.log(obj);
    },
    onChange: function (obj) {      // callback, вызывается при каждом изменении состояния
        console.log(obj);
    },
    onFinish: function (obj) {      // callback, вызывается один раз в конце использования
        console.log(obj);
    }
});
```

Слайдер с параметрами можно также инициализировать используя атрибуты <code>data-*</code> у тэга <code>input</code>:
```html
data-from="30"                      // предустановленное значение ОТ
data-to="70"                        // предустановленное значение ДО
data-type="double"                  // тип слайдера
data-step="10"                      // шаг слайдера
data-prefix="$"                     // префикс значение
data-postfix=" €"                   // постфикс значение
data-maxpostfix="+"                 // постфикс значение для максимального числа
data-hasgrid="true"                 // показать сетку
data-hideminmax="true"              // спрятать поля Min и Max
data-hidefromto="true"              // спрятать поля From и To
data-prettify="false"               // не разделять цифры пробелами 10000 вместо 10 000
data-disable="true"                 // отключить слайдер
data-values="a,b,c"                 // предустановленные значения, элементы через запятую
```

## Публичные методы

Обновление слайдера, метод <code>update</code>:
```javascript
$("#someID").ionRangeSlider("update", {
    min: 20,                        // меняем минимальное значение
    max: 90,                        // меняем максимальное значение
    from: 40,                       // меняем предустановленное значение ОТ
    to: 70,                         // меняем предустановленное значение ДО
    step: 5                         // меняем шаг слайдера
});
```

Удаление слайдера, метод <code>remove</code>:
```javascript
$("#someID").ionRangeSlider("remove");
```

## История обновлений
* 16.03.2014 - Обновление описания плагина. Новый дизайн демок. Несколько новых параметров. Задачи: #65, 68, 70, 77, 78
* 12.01.2014 - Исправлены баги, добавлены новые функции. Задачи: # 12, 30, 33, 43, 47, 52, 58
* 31.10.2013 - Исправлены баги: # 13, 31, 35, 37, 40, несколько мелких оптимизаций кода
* 10.10.2013 - Новый скин Flat UI. Общие оптимизации скинов. Исправлен баг #25.
* 08.10.2013 - Исправлены задачи #20, #21, #23, #24, #26. Удален параметр hideText. Новый метод и настройки. Несколько мелких оптимизаций и улучшено оформление кода.
* 11.09.2013 - Исправлен баг в браузерах на Android-устройствах. Добавлена поддержка отрицательных и дробных чисел. Issues #15, 16
* 23.08.2013 - Исправлено несколько багов и добавлены новые возможности. Так же исправлены Issues #7-10
* 30.06.2013 - исправление мелких багов, новый параметр hideText
* 21.06.2013 - добавлена возможность показывать сетку
* 21.06.2013 - исправление мелких багов
* 06.06.2013 - добавлены публичные методы и произведена оптимизация кода
* 06.06.2013 - мелкие обновления CSS файлов
* 30.04.2013 - добавлен новый метод onFinish
* 15.02.2013 - добавлена возможность настраивать слайдер через атрибуты data-*